difftool: remove the backup file feature
[git/dscho.git] / git-mergetool.sh
blobbe9717a2f10577c8cb83dc124bda4e6169ee39e9
1 #!/bin/sh
3 # This program resolves merge conflicts in git
5 # Copyright (c) 2006 Theodore Y. Ts'o
7 # This file is licensed under the GPL v2, or a later version
8 # at the discretion of Junio C Hamano.
11 USAGE='[--tool=tool] [-y|--no-prompt|--prompt] [file to merge] ...'
12 SUBDIRECTORY_OK=Yes
13 OPTIONS_SPEC=
14 . git-sh-setup
15 require_work_tree
17 # Returns true if the mode reflects a symlink
18 is_symlink () {
19 test "$1" = 120000
22 local_present () {
23 test -n "$local_mode"
26 remote_present () {
27 test -n "$remote_mode"
30 base_present () {
31 test -n "$base_mode"
34 cleanup_temp_files () {
35 if test "$1" = --save-backup ; then
36 mv -- "$BACKUP" "$MERGED.orig"
37 rm -f -- "$LOCAL" "$REMOTE" "$BASE"
38 else
39 rm -f -- "$LOCAL" "$REMOTE" "$BASE" "$BACKUP"
43 describe_file () {
44 mode="$1"
45 branch="$2"
46 file="$3"
48 printf " {%s}: " "$branch"
49 if test -z "$mode"; then
50 echo "deleted"
51 elif is_symlink "$mode" ; then
52 echo "a symbolic link -> '$(cat "$file")'"
53 else
54 if base_present; then
55 echo "modified"
56 else
57 echo "created"
63 resolve_symlink_merge () {
64 while true; do
65 printf "Use (l)ocal or (r)emote, or (a)bort? "
66 read ans
67 case "$ans" in
68 [lL]*)
69 git checkout-index -f --stage=2 -- "$MERGED"
70 git add -- "$MERGED"
71 cleanup_temp_files --save-backup
72 return 0
74 [rR]*)
75 git checkout-index -f --stage=3 -- "$MERGED"
76 git add -- "$MERGED"
77 cleanup_temp_files --save-backup
78 return 0
80 [aA]*)
81 return 1
83 esac
84 done
87 resolve_deleted_merge () {
88 while true; do
89 if base_present; then
90 printf "Use (m)odified or (d)eleted file, or (a)bort? "
91 else
92 printf "Use (c)reated or (d)eleted file, or (a)bort? "
94 read ans
95 case "$ans" in
96 [mMcC]*)
97 git add -- "$MERGED"
98 cleanup_temp_files --save-backup
99 return 0
101 [dD]*)
102 git rm -- "$MERGED" > /dev/null
103 cleanup_temp_files
104 return 0
106 [aA]*)
107 return 1
109 esac
110 done
113 check_unchanged () {
114 if test "$MERGED" -nt "$BACKUP" ; then
115 status=0;
116 else
117 while true; do
118 echo "$MERGED seems unchanged."
119 printf "Was the merge successful? [y/n] "
120 read answer < /dev/tty
121 case "$answer" in
122 y*|Y*) status=0; break ;;
123 n*|N*) status=1; break ;;
124 esac
125 done
129 checkout_staged_file () {
130 tmpfile=$(expr "$(git checkout-index --temp --stage="$1" "$2")" : '\([^ ]*\) ')
132 if test $? -eq 0 -a -n "$tmpfile" ; then
133 mv -- "$(git rev-parse --show-cdup)$tmpfile" "$3"
137 merge_file () {
138 MERGED="$1"
140 f=`git ls-files -u -- "$MERGED"`
141 if test -z "$f" ; then
142 if test ! -f "$MERGED" ; then
143 echo "$MERGED: file not found"
144 else
145 echo "$MERGED: file does not need merging"
147 return 1
150 ext="$$$(expr "$MERGED" : '.*\(\.[^/]*\)$')"
151 BACKUP="./$MERGED.BACKUP.$ext"
152 LOCAL="./$MERGED.LOCAL.$ext"
153 REMOTE="./$MERGED.REMOTE.$ext"
154 BASE="./$MERGED.BASE.$ext"
156 mv -- "$MERGED" "$BACKUP"
157 cp -- "$BACKUP" "$MERGED"
159 base_mode=`git ls-files -u -- "$MERGED" | awk '{if ($3==1) print $1;}'`
160 local_mode=`git ls-files -u -- "$MERGED" | awk '{if ($3==2) print $1;}'`
161 remote_mode=`git ls-files -u -- "$MERGED" | awk '{if ($3==3) print $1;}'`
163 base_present && checkout_staged_file 1 "$MERGED" "$BASE"
164 local_present && checkout_staged_file 2 "$MERGED" "$LOCAL"
165 remote_present && checkout_staged_file 3 "$MERGED" "$REMOTE"
167 if test -z "$local_mode" -o -z "$remote_mode"; then
168 echo "Deleted merge conflict for '$MERGED':"
169 describe_file "$local_mode" "local" "$LOCAL"
170 describe_file "$remote_mode" "remote" "$REMOTE"
171 resolve_deleted_merge
172 return
175 if is_symlink "$local_mode" || is_symlink "$remote_mode"; then
176 echo "Symbolic link merge conflict for '$MERGED':"
177 describe_file "$local_mode" "local" "$LOCAL"
178 describe_file "$remote_mode" "remote" "$REMOTE"
179 resolve_symlink_merge
180 return
183 echo "Normal merge conflict for '$MERGED':"
184 describe_file "$local_mode" "local" "$LOCAL"
185 describe_file "$remote_mode" "remote" "$REMOTE"
186 if "$prompt" = true; then
187 printf "Hit return to start merge resolution tool (%s): " "$merge_tool"
188 read ans
191 case "$merge_tool" in
192 kdiff3)
193 if base_present ; then
194 ("$merge_tool_path" --auto --L1 "$MERGED (Base)" --L2 "$MERGED (Local)" --L3 "$MERGED (Remote)" \
195 -o "$MERGED" "$BASE" "$LOCAL" "$REMOTE" > /dev/null 2>&1)
196 else
197 ("$merge_tool_path" --auto --L1 "$MERGED (Local)" --L2 "$MERGED (Remote)" \
198 -o "$MERGED" "$LOCAL" "$REMOTE" > /dev/null 2>&1)
200 status=$?
202 tkdiff)
203 if base_present ; then
204 "$merge_tool_path" -a "$BASE" -o "$MERGED" "$LOCAL" "$REMOTE"
205 else
206 "$merge_tool_path" -o "$MERGED" "$LOCAL" "$REMOTE"
208 status=$?
210 meld)
211 touch "$BACKUP"
212 "$merge_tool_path" "$LOCAL" "$MERGED" "$REMOTE"
213 check_unchanged
215 vimdiff)
216 touch "$BACKUP"
217 "$merge_tool_path" -d -c "wincmd l" "$LOCAL" "$MERGED" "$REMOTE"
218 check_unchanged
220 gvimdiff)
221 touch "$BACKUP"
222 "$merge_tool_path" -d -c "wincmd l" -f "$LOCAL" "$MERGED" "$REMOTE"
223 check_unchanged
225 xxdiff)
226 touch "$BACKUP"
227 if base_present ; then
228 "$merge_tool_path" -X --show-merged-pane \
229 -R 'Accel.SaveAsMerged: "Ctrl-S"' \
230 -R 'Accel.Search: "Ctrl+F"' \
231 -R 'Accel.SearchForward: "Ctrl-G"' \
232 --merged-file "$MERGED" "$LOCAL" "$BASE" "$REMOTE"
233 else
234 "$merge_tool_path" -X --show-merged-pane \
235 -R 'Accel.SaveAsMerged: "Ctrl-S"' \
236 -R 'Accel.Search: "Ctrl+F"' \
237 -R 'Accel.SearchForward: "Ctrl-G"' \
238 --merged-file "$MERGED" "$LOCAL" "$REMOTE"
240 check_unchanged
242 opendiff)
243 touch "$BACKUP"
244 if base_present; then
245 "$merge_tool_path" "$LOCAL" "$REMOTE" -ancestor "$BASE" -merge "$MERGED" | cat
246 else
247 "$merge_tool_path" "$LOCAL" "$REMOTE" -merge "$MERGED" | cat
249 check_unchanged
251 ecmerge)
252 touch "$BACKUP"
253 if base_present; then
254 "$merge_tool_path" "$BASE" "$LOCAL" "$REMOTE" --default --mode=merge3 --to="$MERGED"
255 else
256 "$merge_tool_path" "$LOCAL" "$REMOTE" --default --mode=merge2 --to="$MERGED"
258 check_unchanged
260 emerge)
261 if base_present ; then
262 "$merge_tool_path" -f emerge-files-with-ancestor-command "$LOCAL" "$REMOTE" "$BASE" "$(basename "$MERGED")"
263 else
264 "$merge_tool_path" -f emerge-files-command "$LOCAL" "$REMOTE" "$(basename "$MERGED")"
266 status=$?
268 tortoisemerge)
269 if base_present ; then
270 touch "$BACKUP"
271 "$merge_tool_path" -base:"$BASE" -mine:"$LOCAL" -theirs:"$REMOTE" -merged:"$MERGED"
272 check_unchanged
273 else
274 echo "TortoiseMerge cannot be used without a base" 1>&2
275 status=1
279 if test -n "$merge_tool_cmd"; then
280 if test "$merge_tool_trust_exit_code" = "false"; then
281 touch "$BACKUP"
282 ( eval $merge_tool_cmd )
283 check_unchanged
284 else
285 ( eval $merge_tool_cmd )
286 status=$?
290 esac
291 if test "$status" -ne 0; then
292 echo "merge of $MERGED failed" 1>&2
293 mv -- "$BACKUP" "$MERGED"
295 if test "$merge_keep_temporaries" = "false"; then
296 cleanup_temp_files
299 return 1
302 if test "$merge_keep_backup" = "true"; then
303 mv -- "$BACKUP" "$MERGED.orig"
304 else
305 rm -- "$BACKUP"
308 git add -- "$MERGED"
309 cleanup_temp_files
310 return 0
313 prompt=$(git config --bool mergetool.prompt || echo true)
315 while test $# != 0
317 case "$1" in
318 -t|--tool*)
319 case "$#,$1" in
320 *,*=*)
321 merge_tool=`expr "z$1" : 'z-[^=]*=\(.*\)'`
323 1,*)
324 usage ;;
326 merge_tool="$2"
327 shift ;;
328 esac
330 -y|--no-prompt)
331 prompt=false
333 --prompt)
334 prompt=true
337 shift
338 break
341 usage
344 break
346 esac
347 shift
348 done
350 valid_custom_tool()
352 merge_tool_cmd="$(git config mergetool.$1.cmd)"
353 test -n "$merge_tool_cmd"
356 valid_tool() {
357 case "$1" in
358 kdiff3 | tkdiff | xxdiff | meld | opendiff | emerge | vimdiff | gvimdiff | ecmerge | tortoisemerge)
359 ;; # happy
361 if ! valid_custom_tool "$1"; then
362 return 1
365 esac
368 init_merge_tool_path() {
369 merge_tool_path=`git config mergetool.$1.path`
370 if test -z "$merge_tool_path" ; then
371 case "$1" in
372 vimdiff)
373 merge_tool_path=vim
375 gvimdiff)
376 merge_tool_path=gvim
378 emerge)
379 merge_tool_path=emacs
382 merge_tool_path=$1
384 esac
388 prompt_after_failed_merge() {
389 while true; do
390 printf "Continue merging other unresolved paths (y/n) ? "
391 read ans
392 case "$ans" in
394 [yY]*)
395 return 0
398 [nN]*)
399 return 1
401 esac
402 done
405 if test -z "$merge_tool"; then
406 merge_tool=`git config merge.tool`
407 if test -n "$merge_tool" && ! valid_tool "$merge_tool"; then
408 echo >&2 "git config option merge.tool set to unknown tool: $merge_tool"
409 echo >&2 "Resetting to default..."
410 unset merge_tool
414 if test -z "$merge_tool" ; then
415 if test -n "$DISPLAY"; then
416 if test -n "$GNOME_DESKTOP_SESSION_ID" ; then
417 merge_tool_candidates="meld kdiff3 tkdiff xxdiff tortoisemerge gvimdiff"
418 else
419 merge_tool_candidates="kdiff3 tkdiff xxdiff meld tortoisemerge gvimdiff"
422 if echo "${VISUAL:-$EDITOR}" | grep 'emacs' > /dev/null 2>&1; then
423 merge_tool_candidates="$merge_tool_candidates emerge opendiff vimdiff"
424 elif echo "${VISUAL:-$EDITOR}" | grep 'vim' > /dev/null 2>&1; then
425 merge_tool_candidates="$merge_tool_candidates vimdiff opendiff emerge"
426 else
427 merge_tool_candidates="$merge_tool_candidates opendiff emerge vimdiff"
429 echo "merge tool candidates: $merge_tool_candidates"
430 for i in $merge_tool_candidates; do
431 init_merge_tool_path $i
432 if type "$merge_tool_path" > /dev/null 2>&1; then
433 merge_tool=$i
434 break
436 done
437 if test -z "$merge_tool" ; then
438 echo "No known merge resolution program available."
439 exit 1
441 else
442 if ! valid_tool "$merge_tool"; then
443 echo >&2 "Unknown merge_tool $merge_tool"
444 exit 1
447 init_merge_tool_path "$merge_tool"
449 merge_keep_backup="$(git config --bool merge.keepBackup || echo true)"
450 merge_keep_temporaries="$(git config --bool mergetool.keepTemporaries || echo false)"
452 if test -z "$merge_tool_cmd" && ! type "$merge_tool_path" > /dev/null 2>&1; then
453 echo "The merge tool $merge_tool is not available as '$merge_tool_path'"
454 exit 1
457 if ! test -z "$merge_tool_cmd"; then
458 merge_tool_trust_exit_code="$(git config --bool mergetool.$merge_tool.trustExitCode || echo false)"
462 last_status=0
463 rollup_status=0
465 if test $# -eq 0 ; then
466 files=`git ls-files -u | sed -e 's/^[^ ]* //' | sort -u`
467 if test -z "$files" ; then
468 echo "No files need merging"
469 exit 0
471 echo Merging the files: "$files"
472 git ls-files -u |
473 sed -e 's/^[^ ]* //' |
474 sort -u |
475 while IFS= read i
477 if test $last_status -ne 0; then
478 prompt_after_failed_merge < /dev/tty || exit 1
480 printf "\n"
481 merge_file "$i" < /dev/tty > /dev/tty
482 last_status=$?
483 if test $last_status -ne 0; then
484 rollup_status=1
486 done
487 else
488 while test $# -gt 0; do
489 if test $last_status -ne 0; then
490 prompt_after_failed_merge || exit 1
492 printf "\n"
493 merge_file "$1"
494 last_status=$?
495 if test $last_status -ne 0; then
496 rollup_status=1
498 shift
499 done
502 exit $rollup_status